hdu 1963 poj 2063 Investment(完全背包)

来源:互联网 发布:php 返回404页面 编辑:程序博客网 时间:2024/05/01 12:16

Language:
Investment
Time Limit: 1000MS Memory Limit: 30000KTotal Submissions: 9191 Accepted: 3186

Description

John never knew he had a grand-uncle, until he received the notary's letter. He learned that his late grand-uncle had gathered a lot of money, somewhere in South-America, and that John was the only inheritor. 
John did not need that much money for the moment. But he realized that it would be a good idea to store this capital in a safe place, and have it grow until he decided to retire. The bank convinced him that a certain kind of bond was interesting for him. 
This kind of bond has a fixed value, and gives a fixed amount of yearly interest, payed to the owner at the end of each year. The bond has no fixed term. Bonds are available in different sizes. The larger ones usually give a better interest. Soon John realized that the optimal set of bonds to buy was not trivial to figure out. Moreover, after a few years his capital would have grown, and the schedule had to be re-evaluated. 
Assume the following bonds are available: 
ValueAnnual
interest4000
3000400
250

With a capital of e10 000 one could buy two bonds of $4 000, giving a yearly interest of $800. Buying two bonds of $3 000, and one of $4 000 is a better idea, as it gives a yearly interest of $900. After two years the capital has grown to $11 800, and it makes sense to sell a $3 000 one and buy a $4 000 one, so the annual interest grows to $1 050. This is where this story grows unlikely: the bank does not charge for buying and selling bonds. Next year the total sum is $12 850, which allows for three times $4 000, giving a yearly interest of $1 200. 
Here is your problem: given an amount to begin with, a number of years, and a set of bonds with their values and interests, find out how big the amount may grow in the given period, using the best schedule for buying and selling bonds.

Input

The first line contains a single positive integer N which is the number of test cases. The test cases follow. 
The first line of a test case contains two positive integers: the amount to start with (at most $1 000 000), and the number of years the capital may grow (at most 40). 
The following line contains a single number: the number d (1 <= d <= 10) of available bonds. 
The next d lines each contain the description of a bond. The description of a bond consists of two positive integers: the value of the bond, and the yearly interest for that bond. The value of a bond is always a multiple of $1 000. The interest of a bond is never more than 10% of its value.

Output

For each test case, output – on a separate line – the capital at the end of the period, after an optimal schedule of buying and selling.

Sample Input

110000 424000 4003000 250



一开始有mon多的钱 然后通过y年来进行投资  现在有n中投资方式 每种投资方式都有投入和收益

问经过这y年之后  最多能有多少钱


前一年的投资收益可以应用到下一年继续进行投资

所以在每一年中 对于每种投资方式都可以选择多次 这就可以转化为完全背包问题了。。

另外由于所有的投入都是1000的倍数 所以我们可以除以1000 来处理数据

#include <cstdio>#include <iostream>#include <cstring>#include <cmath>#include <algorithm>#include <string.h>#include <string>#include <vector>#include <queue>#define MEM(a,x) memset(a,x,sizeof a)#define eps 1e-8#define MOD 10009#define MAXN 100010#define MAXM 100010#define INF 99999999#define ll __int64#define bug cout<<"here"<<endl#define fread freopen("ceshi.txt","r",stdin)#define fwrite freopen("out.txt","w",stdout)using namespace std;int Read(){    char c = getchar();    while (c < '0' || c > '9') c = getchar();    int x = 0;    while (c >= '0' && c <= '9') {        x = x * 10 + c - '0';        c = getchar();    }    return x;}void Print(int a){     if(a>9)         Print(a/10);     putchar(a%10+'0');}int dp[MAXN];int cost[20],val[20];int main(){//    fread;    int tc;    scanf("%d",&tc);    while(tc--)    {        int mon,y;        int n;        scanf("%d%d%d",&mon,&y,&n);        for(int i=0;i<n;i++)        {            scanf("%d%d",&cost[i],&val[i]);            cost[i]/=1000;        }        MEM(dp,0);        int sum;        for(int i=0;i<y;i++)        {            sum=mon/1000;            for(int j=0;j<n;j++)            {                for(int k=cost[j];k<=sum;k++)                {                    dp[k]=max(dp[k],dp[k-cost[j]]+val[j]);                }            }            mon+=dp[sum];        }        printf("%d\n",mon);    }    return 0;}




0 0
原创粉丝点击